﻿
namespace SilverlightApplicationSchool.Web
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Data;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;


    // Implements application logic using the SchoolEntities context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class DomainServiceSchool : LinqToEntitiesDomainService<SchoolEntities>
    {

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Courses' query.
        public IQueryable<Course> GetCourses()
        {
            return this.ObjectContext.Courses;
        }

        public void InsertCourse(Course course)
        {
            if ((course.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(course, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Courses.AddObject(course);
            }
        }

        public void UpdateCourse(Course currentCourse)
        {
            this.ObjectContext.Courses.AttachAsModified(currentCourse, this.ChangeSet.GetOriginal(currentCourse));
        }

        public void DeleteCourse(Course course)
        {
            if ((course.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Courses.Attach(course);
            }
            this.ObjectContext.Courses.DeleteObject(course);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Departments' query.
        public IQueryable<Department> GetDepartments()
        {
            return this.ObjectContext.Departments;
        }

        public void InsertDepartment(Department department)
        {
            if ((department.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(department, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Departments.AddObject(department);
            }
        }

        public void UpdateDepartment(Department currentDepartment)
        {
            this.ObjectContext.Departments.AttachAsModified(currentDepartment, this.ChangeSet.GetOriginal(currentDepartment));
        }

        public void DeleteDepartment(Department department)
        {
            if ((department.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Departments.Attach(department);
            }
            this.ObjectContext.Departments.DeleteObject(department);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'OfficeAssignments' query.
        public IQueryable<OfficeAssignment> GetOfficeAssignments()
        {
            return this.ObjectContext.OfficeAssignments;
        }

        public void InsertOfficeAssignment(OfficeAssignment officeAssignment)
        {
            if ((officeAssignment.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(officeAssignment, EntityState.Added);
            }
            else
            {
                this.ObjectContext.OfficeAssignments.AddObject(officeAssignment);
            }
        }

        public void UpdateOfficeAssignment(OfficeAssignment currentOfficeAssignment)
        {
            this.ObjectContext.OfficeAssignments.AttachAsModified(currentOfficeAssignment, this.ChangeSet.GetOriginal(currentOfficeAssignment));
        }

        public void DeleteOfficeAssignment(OfficeAssignment officeAssignment)
        {
            if ((officeAssignment.EntityState == EntityState.Detached))
            {
                this.ObjectContext.OfficeAssignments.Attach(officeAssignment);
            }
            this.ObjectContext.OfficeAssignments.DeleteObject(officeAssignment);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'OnlineCourses' query.
        public IQueryable<OnlineCourse> GetOnlineCourses()
        {
            return this.ObjectContext.OnlineCourses;
        }

        public void InsertOnlineCourse(OnlineCourse onlineCourse)
        {
            if ((onlineCourse.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(onlineCourse, EntityState.Added);
            }
            else
            {
                this.ObjectContext.OnlineCourses.AddObject(onlineCourse);
            }
        }

        public void UpdateOnlineCourse(OnlineCourse currentOnlineCourse)
        {
            this.ObjectContext.OnlineCourses.AttachAsModified(currentOnlineCourse, this.ChangeSet.GetOriginal(currentOnlineCourse));
        }

        public void DeleteOnlineCourse(OnlineCourse onlineCourse)
        {
            if ((onlineCourse.EntityState == EntityState.Detached))
            {
                this.ObjectContext.OnlineCourses.Attach(onlineCourse);
            }
            this.ObjectContext.OnlineCourses.DeleteObject(onlineCourse);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'OnsiteCourses' query.
        public IQueryable<OnsiteCourse> GetOnsiteCourses()
        {
            return this.ObjectContext.OnsiteCourses;
        }

        public void InsertOnsiteCourse(OnsiteCourse onsiteCourse)
        {
            if ((onsiteCourse.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(onsiteCourse, EntityState.Added);
            }
            else
            {
                this.ObjectContext.OnsiteCourses.AddObject(onsiteCourse);
            }
        }

        public void UpdateOnsiteCourse(OnsiteCourse currentOnsiteCourse)
        {
            this.ObjectContext.OnsiteCourses.AttachAsModified(currentOnsiteCourse, this.ChangeSet.GetOriginal(currentOnsiteCourse));
        }

        public void DeleteOnsiteCourse(OnsiteCourse onsiteCourse)
        {
            if ((onsiteCourse.EntityState == EntityState.Detached))
            {
                this.ObjectContext.OnsiteCourses.Attach(onsiteCourse);
            }
            this.ObjectContext.OnsiteCourses.DeleteObject(onsiteCourse);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'People' query.
        public IQueryable<Person> GetPeople()
        {
            return this.ObjectContext.People;
        }

        public void InsertPerson(Person person)
        {
            if ((person.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(person, EntityState.Added);
            }
            else
            {
                this.ObjectContext.People.AddObject(person);
            }
        }

        public void UpdatePerson(Person currentPerson)
        {
            this.ObjectContext.People.AttachAsModified(currentPerson, this.ChangeSet.GetOriginal(currentPerson));
        }

        public void DeletePerson(Person person)
        {
            if ((person.EntityState == EntityState.Detached))
            {
                this.ObjectContext.People.Attach(person);
            }
            this.ObjectContext.People.DeleteObject(person);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'StudentGrades' query.
        public IQueryable<StudentGrade> GetStudentGrades()
        {
            return this.ObjectContext.StudentGrades;
        }

        public void InsertStudentGrade(StudentGrade studentGrade)
        {
            if ((studentGrade.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(studentGrade, EntityState.Added);
            }
            else
            {
                this.ObjectContext.StudentGrades.AddObject(studentGrade);
            }
        }

        public void UpdateStudentGrade(StudentGrade currentStudentGrade)
        {
            this.ObjectContext.StudentGrades.AttachAsModified(currentStudentGrade, this.ChangeSet.GetOriginal(currentStudentGrade));
        }

        public void DeleteStudentGrade(StudentGrade studentGrade)
        {
            if ((studentGrade.EntityState == EntityState.Detached))
            {
                this.ObjectContext.StudentGrades.Attach(studentGrade);
            }
            this.ObjectContext.StudentGrades.DeleteObject(studentGrade);
        }
    }
}


